﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Data;
using System.Text.RegularExpressions;

using System.Windows.Forms;
using System.Threading;

namespace WindowsFormsApplication1
{
   public class Document
    {
       
        String wFolder = @"";
        Recorder rec = null;
        int currentWork = -1;
        DataTable db = null;
        Iserv frm;
        static Main fmain;
        private const int R_FILE = 0;
        private const int R_TIME = 1;
        private const int R_BAD = 2;
        private const int R_UTT = 3;
        private const int R_COM = 4;
        private const int R_EXT = 5;

        private Boolean allDone = false;
        private Boolean docSaved = true;


        int counter;

        public Document(Main m)
        {
            fmain = m;
            newDoc();
        }
        public int getWorkSize()
        {
            return db.Rows.Count;
        }
        public int getWorkDone()
        {
            int counter = 0;
            for (int i = 0; i < db.Rows.Count; i++)
            {
                if (!String.Equals((String)db.Rows[i][R_TIME], "", StringComparison.Ordinal))
                {
                    counter++;
                }
            }
            return counter;
        }
        public int getNextWork()
        {

            for (int i = 0; i < db.Rows.Count; i++)
            {
                if (String.Equals((String)db.Rows[i][R_TIME], "", StringComparison.Ordinal))
                {
                    return i;
                }
            }
            return -1;
        }

        public Boolean isGCinit()
        {
            if (frm == null)
            {
                return false;
            }
            else
            {
                return true;
            }
        }

        public void gcInit()
        {
                if (rec != null)
                {
                    rec.close();
                    rec = null;
                    
                }
                rec = new Recorder();
                frm = new Iserv(this);
                allDone = false;

               
                 frm.Show();

        }
        public void gcClose()
        {
            System.Console.WriteLine("gcClose");
            
                frm.Close();
                frm = null;
            
                    
                fmain.updateStats();
        }

        public void gcCloseF()
        {
            System.Console.WriteLine("gcCloseF");

            if (rec != null)
            {
                rec.close();
                rec = null;
            }

            fmain.updateStats();
        }

        public void gcNext()
        {
            System.Console.WriteLine("gcNext");
            if (rec == null) {
                return;
            }
            if (rec.isRecording())
            {
                String a = rec.stopRec();
                db.Columns[R_TIME].ReadOnly = false;
                db.Rows[currentWork][R_TIME] = a;
                db.Columns[R_TIME].ReadOnly = true;
                docSaved = false;
            }
            currentWork = getNextWork();
            if (!allDone)
            {
                if (currentWork > -1)
                {
                    frm.setUtt((String)db.Rows[currentWork][R_UTT]);
                    fmain.setUtt((String)db.Rows[currentWork][R_UTT]);
                    rec.startRec(wFolder + db.Rows[currentWork][R_FILE]);
                    addCount();
                    fmain.updateStats();
                }
                else
                {
                    allDone = true;
                    frm.setUtt("Valmis !!!");
                    fmain.setUtt("Valmis !!!");
                    fmain.updateStats();
                }
            }
            else {

                gcClose();
            }

        }
        public void gcPause()
        {
            if (rec == null)
            {
                return;
            }
            if (rec.isRecording())
            {
                String a = rec.stopRec();
                frm.setUtt("Pausis !!!");
                fmain.setUtt("Pausis !!!");
            }
        }
        public void newDoc()
        {

            db = new DataTable();

            db.Columns.Add("Fail", typeof(String));
            db.Columns[R_FILE].ReadOnly = true;

            db.Columns.Add("Aeg", typeof(String));
            db.Columns[R_TIME].ReadOnly = true;

            db.Columns.Add("Halb", typeof(String));
            db.Columns[R_BAD].ReadOnly = true;

            db.Columns.Add("Sisu", typeof(String));
            db.Columns[R_UTT].ReadOnly = true;

            db.Columns.Add("Kommentaar", typeof(String));

            db.Columns.Add("EXT", typeof(String));
            db.Columns[R_EXT].ReadOnly = true;
            
            //dGV.DataSource = resultsList;
            //dGV.AutoGenerateColumns = false;


            //dGV.Columns[3].Visible = false; 

            //db.Columns[R_TIME].ReadOnly = false;
            //db.Rows[3][R_TIME] = "00:00:06";
            //db.Columns[R_TIME].ReadOnly = true;

        }

        public DataTable getDS()
        {

            return db;

        }
        public void save(System.IO.FileStream file)
        {

            System.IO.StreamWriter writer = new System.IO.StreamWriter(file);
            writer.WriteLine("!FOLDER\t" + wFolder + "");
            for (int i = 0; i < db.Rows.Count; i++)
            {

                writer.WriteLine(db.Rows[i][R_FILE] + "\t" + db.Rows[i][R_TIME] + "\t" + db.Rows[i][R_BAD] + "\t" + db.Rows[i][R_UTT] + "\t" + db.Rows[i][R_COM] + "\t" + db.Rows[i][R_EXT] + ""); //\r\n
            }
            writer.Flush();
            docSaved = true;
        }

        public void load(System.IO.StreamReader file)
        {
            int counter = 0;
            string line;
 
            while ((line = file.ReadLine()) != null)
            {
                Match match = Regex.Match(line, @"^!FOLDER\t(.+)$", RegexOptions.IgnoreCase);
                if (match.Success)
                {
                    wFolder = match.Groups[1].Value;

                    continue;
                }

                match = Regex.Match(line, @"^(.+)\t(.*)\t(.*)\t(.+)\t(.*)\t(.*)$", RegexOptions.IgnoreCase);
                if (match.Success)
                {
                    db.Rows.Add(match.Groups[1].Value, match.Groups[2].Value, match.Groups[3].Value, match.Groups[4].Value, match.Groups[5].Value, match.Groups[6].Value);
                }
                
                counter++;
            }

            file.Close();
            System.Console.WriteLine("There were {0} lines.", counter);
            // Suspend the screen.
        
        }

        public void loadTXT(System.IO.StreamReader file)
        {
            int counter = 1;
            string line;

            while ((line = file.ReadLine()) != null)
            {

                db.Rows.Add("eki_et_adp_" + counter.ToString("D5") + ".wav", "", "", line, "", "");
                counter++;
            }

            file.Close();
            System.Console.WriteLine("There were {0} lines.", counter);
            // Suspend the screen.

        }
       
        public void loadInternalWork()
        {
            int counter = 0;

            foreach (string line in laused.work)
            {
                counter++;
                db.Rows.Add("eki_et_adp_" + counter.ToString("D5") + ".wav", "", "", line, "", "");
            }


            System.Console.WriteLine("There were {0} lines.", counter);
            // Suspend the screen.

        }


        public void loadDemoset()
        {
            wFolder = @"";
            db.Rows.Add("F0001.wav", "", "", "test", "", "");
            db.Rows.Add("F0002.wav", "", "", "auto", "", "");
            db.Rows.Add("F0003.wav", "", "", "kala", "", "");
            db.Rows.Add("F0004.wav", "", "", "kirst", "", "");
            db.Rows.Add("F0005.wav", "", "", "kosmos", "", "");
            db.Rows.Add("F0006.wav", "", "", "ja", "", "");
            db.Rows.Add("F0007.wav", "", "", "nägu", "", "");
            db.Rows.Add("F0008.wav", "", "", "laevuke", "", "");
            db.Rows.Add("F0009.wav", "", "", "kino", "", "");

        }


        public void initCount()
        {
            counter = 0;
        }

        public void addCount()
        {
            counter = counter +1;
        }

        public int getCount()
        {
            return counter;
        }

        internal void setWF(string path)
        {
            wFolder = path;
            docSaved = false;
        }

        internal string getWF()
        {
            return wFolder;
        }



        internal void setRowStatus(DataRow row)
        {
            db.Columns[R_BAD].ReadOnly = false;
            if ("halb" == (String)row[R_BAD])
            {
                row[R_BAD] = "";
            }else{
                row[R_BAD] = "halb";
            }

            db.Columns[R_BAD].ReadOnly = true;
            docSaved = false;
        }

        internal void ClearRowDone(DataRow row)
        {
            db.Columns[R_TIME].ReadOnly = false;
            row[R_TIME] = "";
            db.Columns[R_TIME].ReadOnly = true;
            docSaved = false;
        }
    }
}
