﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Threading;
using ConsoleHotKey;


namespace WindowsFormsApplication1
{
    public partial class Main : Form
    {
        delegate void updateStatsCallback();
        delegate void rPressedCallback(int m);
        delegate void SetTextCallback(string text);
        Document wDoc;

        static Main fmain;
        int _hkNext;
        int _hkRetry;

        public Main()
        {
            fmain = this;
            InitializeComponent();

            _hkNext = HotKeyManager.RegisterHotKey(Keys.F10, KeyModifiers.NoRepeat);
            _hkRetry = HotKeyManager.RegisterHotKey(Keys.F11, KeyModifiers.NoRepeat);

            HotKeyManager.HotKeyPressed += new EventHandler<HotKeyEventArgs>(HotKeyManager_HotKeyPressed);

            //HotKeyManager.UnregisterHotKey(_hkNext);
            //HotKeyManager.UnregisterHotKey(_hkRetry);
            //_hkNext = 0;
            //_hkRetry = 0;

        }


        private void init()
        {

            wDoc = new Document(this);
            dGV.DataSource = wDoc.getDS();
            dGV.AutoGenerateColumns = false;
            dGV.Columns[0].AutoSizeMode = DataGridViewAutoSizeColumnMode.AllCells;
            dGV.Columns[1].AutoSizeMode = DataGridViewAutoSizeColumnMode.AllCells;
            //   dGV.Columns[1].ReadOnly = true;

            dGV.Columns[2].AutoSizeMode = DataGridViewAutoSizeColumnMode.ColumnHeader;
            // dGV.Columns[2].CellType = DataGridViewButtonCell;
            dGV.Columns[2].ReadOnly = true;
            dGV.Columns[3].AutoSizeMode = DataGridViewAutoSizeColumnMode.Fill;
            dGV.Columns[4].AutoSizeMode = DataGridViewAutoSizeColumnMode.Fill;
            dGV.Columns[5].Visible = false;
            updateStats();
        }
        public void updateStats()
        {
            if (this.llWD.InvokeRequired)
            {
                updateStatsCallback d = new updateStatsCallback(updateStats);
                this.Invoke(d, new object[] { });
                return;
            }


            counterBox.Text = "" + wDoc.getCount();
            llWD.Text = "Tööjärg:" + wDoc.getWorkDone() + "/" + wDoc.getWorkSize();
            IIFL.Text = wDoc.getWF();
            if (wDoc.getWorkSize() > wDoc.getWorkDone())
            {
                ssButton.Enabled = true;
            }
            else
            {
                ssButton.Enabled = false;
            }
            if (wDoc.isGCinit())
            {
                btnWorkFolder.Enabled = false;
                ssButton.Text = "Peata töö";
            }
            else
            {
                btnWorkFolder.Enabled = true;
                ssButton.Text = "Alusta tööga";
            }



        }

        private void button1_Click(object sender, EventArgs e)
        {
            wDoc.gcNext();
        }

        private void Main_Load(object sender, EventArgs e)
        {
            init();
        }


        private Boolean folderOK()
        {
            try
            {
                System.Security.AccessControl.DirectorySecurity ds = System.IO.Directory.GetAccessControl(wDoc.getWF());
                return true;
            }
            catch (Exception ex)
            {
                if (ex is UnauthorizedAccessException || ex is System.InvalidOperationException || ex is System.ArgumentException)
                {
                    return false;
                }
                throw;
            }

        }

        private void ssButton_Click(object sender, EventArgs e)
        {
            System.Console.WriteLine("ssButton_Click");
            if (!wDoc.isGCinit())
            {
                if (folderOK())
                {
                    wDoc.gcInit();
                }
                else
                {
                    MessageBox.Show("Vali Töö kaust.", "VALI...", MessageBoxButtons.OK);
                }
            }
            else
            {
                wDoc.gcClose();
            }
            updateStats();
        }

        private void uusToolStripMenuItem_Click(object sender, EventArgs e)
        {
            init();

        }

        private void laeToolStripMenuItem_Click(object sender, EventArgs e)
        {

            // Kas on vaja salvestada?

            init();
            OpenFileDialog fd = new OpenFileDialog();
            fd.Filter = "Tööfail|*.kj1|TXT Import|*.txt";
            fd.Title = "Lae töö fail";

            if (fd.ShowDialog() == DialogResult.OK)
            {
                System.IO.StreamReader sr = new System.IO.StreamReader(fd.FileName);

                // NOTE that the FilterIndex property is one-based.
                switch (fd.FilterIndex)
                {
                    case 1:
                        wDoc.load(sr);
                        break;

                    case 2:
                        wDoc.loadTXT(sr);
                        break;

                    case 3:
                        break;
                }
            }
            updateStats();
        }

        private void salvestaToolStripMenuItem_Click(object sender, EventArgs e)
        {
            SaveFileDialog fd = new SaveFileDialog();
            fd.Filter = "Tööfail|*.kj1";
            fd.Title = "Salvesta töö";
            fd.ShowDialog();

            if (fd.FileName != "")
            {
                System.IO.FileStream fs =
                     (System.IO.FileStream)fd.OpenFile();

                // NOTE that the FilterIndex property is one-based.
                switch (fd.FilterIndex)
                {
                    case 1:
                        wDoc.save(fs);
                        break;

                    case 2:

                        break;

                    case 3:

                        break;
                }

                fs.Close();
            }
            updateStats();
        }

        private void button3_Click(object sender, EventArgs e)
        {
            wDoc.gcPause();

        }

        private void btnWorkFolder_Click(object sender, EventArgs e)
        {
            FolderBrowserDialog fd = new FolderBrowserDialog();
            if (fd.ShowDialog() == DialogResult.OK)
            {
                IIFL.Text = fd.SelectedPath + "\\";
                wDoc.setWF(fd.SelectedPath + "\\");
            }
        }

        private void demosetToolStripMenuItem_Click(object sender, EventArgs e)
        {
            init();
            wDoc.loadDemoset();
            updateStats();
        }


        public void rPressed(int m)
        {
            rPressedCallback d = new rPressedCallback(rPressedi);
            this.Invoke(d, new object[] { m });

        }

        private void rPressedi(int m)
        {
            if (m == 1)
            {
                wDoc.gcNext();
            }

            if (m == 2)
            {
                wDoc.gcPause();
            }

        }

        static void HotKeyManager_HotKeyPressed(object sender, HotKeyEventArgs hotKey)
        {

            if (hotKey.Key == Keys.F10)
            {
                System.Console.WriteLine("OnHotKeyHandler NEXT");
                fmain.rPressed(1);
            }


            if (hotKey.Key == Keys.F11)
            {
                System.Console.WriteLine("OnHotKeyHandler Pause");
                fmain.rPressed(2);
            }
        }

        public void setUtt(String utt)
        {

            if (this.uUttText.InvokeRequired)
            {
                SetTextCallback d = new SetTextCallback(setUtt);
                this.Invoke(d, new object[] { utt });
            }
            else
            {
                this.uUttText.Text = utt;
            }

        }

        private void button4_Click(object sender, EventArgs e)
        {
            wDoc.initCount();
            updateStats();
        }

        private void scroll_button_Click(object sender, EventArgs e)
        {
            int a = wDoc.getNextWork() - 4;
            if (a < 0)
            {
                a = 0;
            }
            dGV.FirstDisplayedScrollingRowIndex = a;
        }

        private void dGV_CellContentClick(object sender, DataGridViewCellEventArgs e)
        {

            //  MessageBox.Show("R:" + e.RowIndex + " C:" + e.ColumnIndex, "CellMouseClick Event");

            if (e.ColumnIndex == 2)
            {
                if (e.RowIndex > -1)
                {
                    DataRow row = (dGV.Rows[e.RowIndex].DataBoundItem as DataRowView).Row;
                    wDoc.setRowStatus(row);

                }
            }


        }

        private void dGV_CellContentDClick(object sender, DataGridViewCellEventArgs e)
        {

            // MessageBox.Show("R:" + e.RowIndex + " C:" + e.ColumnIndex, "CellMouseClick Event");
            if (e.ColumnIndex == 1)
            {
                if (e.RowIndex > -1)
                {
                    DataRow row = (dGV.Rows[e.RowIndex].DataBoundItem as DataRowView).Row;
                    wDoc.ClearRowDone(row);
                }
            }
        }

        private void dGV_CellContentClick_1(object sender, DataGridViewCellEventArgs e)
        {

        }

        private void Main_FormClosing(object sender, FormClosingEventArgs e)
        {
            if (wDoc.isGCinit())
            {
                wDoc.gcClose();
            }
        }

        private void tööToolStripMenuItem_Click(object sender, EventArgs e)
        {
            init();
            wDoc.loadInternalWork();
            updateStats();
        }
    }
}
