﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using NAudio.Wave;
using System.IO;

namespace WindowsFormsApplication1
{
    class Recorder
    {
        int sampleRate = 22000;
        int nBits = 16;
        int channels = 2;
        Boolean isRec = false;

        private WaveIn waveIn;
        private AsioOut asioOut;
        private WaveFileWriter writer;

        String outputFilename = @"c:\test.wav";

        //public Recorder(int sampleRate = 22000, int nBits = 16, int channels = 2)
        //public Recorder(int sampleRate = 192000, int nBits = 32, int channels = 2)
        public Recorder(int sampleRate = 48000, int nBits = 16, int channels = 1)
        {
            this.sampleRate = Properties.Settings.Default.raudSampleRate;
            this.sampleRate = sampleRate;
            this.nBits = nBits;
            this.channels = channels;
            init();
        }

        ~Recorder()
        {
            close();
        }


        private void init()
        {
            System.Console.WriteLine("Recorder  Init");
            //asioOut = new AsioOut();
            //asioOut.InitRecordAndPlayback(null, channels, sampleRate);
            waveIn = new WaveIn();
            waveIn.WaveFormat = new WaveFormat(sampleRate, nBits, channels);
            waveIn.DeviceNumber = 0;
            waveIn.DataAvailable +=  new EventHandler<WaveInEventArgs>(waveIn_DataAvailable);
            waveIn.StartRecording();
        }


        public void close()
        {
            System.Console.WriteLine("Recorder close");
            if (isRec){
                stopRec();
                waveIn.StopRecording();
            }

            if (writer != null)
            {
                writer.Close();
            }
            waveIn.Dispose();

        }


        private void waveIn_DataAvailable(object sender, WaveInEventArgs e)
        {
            if (writer != null)
            {
                writer.Write(e.Buffer, 0, e.BytesRecorded);
            }
        }

        public String stopRec()
        {
            System.Console.WriteLine("Stop rec");
            isRec = false;
            writer.Flush();
            long lout = writer.Length;
            writer.Close();
            writer = null;
            return lengthToString(lout);
        }

        public void startRec(String outputFilename)
        {
            System.Console.WriteLine("Start rec");
            if(isRec){
                stopRec();
            }
            this.outputFilename = outputFilename;
            chkFile(outputFilename);
            isRec = true;
            writer = new WaveFileWriter(outputFilename, waveIn.WaveFormat);
            
        }

        public String lengthToString(long l)
        {
            long bMin = sampleRate * channels * (nBits / 8);
            long secs = l / bMin;
            long ms = ((l % bMin) * 1000) / bMin;
            return secs + ":" + ms;
        }
        public Boolean isRecording() {

            return isRec;
        }

        private void chkFile(String name) {
            if (File.Exists(name))
            {
                int i;
                for (i = 0; File.Exists(name + "."+i); i++)
                {

                }
                File.Move(name, name + "."+i);
            }
        }
    }
}
