﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using NAudio.Wave;

namespace WindowsFormsApplication1
{
    class Recorder
    {
        int sampleRate = 22000;
        int nBits = 16;
        int channels = 2;
        Boolean isRec = false;

        private WaveIn waveIn;

        private AsioOut asioOut;
        private WaveFileWriter writer;

        String outputFilename = @"c:\test.wav";

        //public Recorder(int sampleRate = 22000, int nBits = 16, int channels = 2)
        public Recorder(int sampleRate = 192000, int nBits = 32, int channels = 2)
        {
            this.sampleRate = Properties.Settings.Default.raudSampleRate;
            this.sampleRate = sampleRate;
            this.nBits = nBits;
            this.channels = channels;
            init();
        }

        ~Recorder()
        {
            close();
        }


        private void init()
        {

            //asioOut = new AsioOut();
            //asioOut.InitRecordAndPlayback(null, channels, sampleRate);
            waveIn = new WaveIn();
            waveIn.WaveFormat = new WaveFormat(sampleRate, nBits, channels);
            waveIn.DeviceNumber = 0;
            waveIn.DataAvailable +=  new EventHandler<WaveInEventArgs>(waveIn_DataAvailable);
            

        }


        private void close()
        {
            waveIn.Dispose();
        }


        private void waveIn_DataAvailable(object sender, WaveInEventArgs e)
        {
            if (writer != null)
            {
                writer.Write(e.Buffer, 0, e.BytesRecorded);
            }

        }

        public String stopRec()
        {
            isRec = false;
            waveIn.StopRecording();
            writer.Flush();
            long lout = writer.Length;
            writer.Close();
            // häkk
            waveIn.Dispose();
            init();
          //  writer = null;
            //waveIn.StartRecording();
            //waveIn.StopRecording();
            // /häkk
            return lengthToString(lout);
        }
        public void startRec(String outputFilename)
        {
            this.outputFilename = outputFilename;
            writer = new WaveFileWriter(outputFilename, waveIn.WaveFormat);
            isRec = true;
            waveIn.StartRecording();
  
        }
        public String lengthToString(long l)
        {
            long bMin = sampleRate * channels * (nBits / 8);
            long secs = l / bMin;
            long ms = ((l % bMin) * 1000) / bMin;
            return secs + ":" + ms;
        }
        public Boolean isRecording() {

            return isRec;
        }
    }
}
