﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using NAudio.Wave;

namespace WindowsFormsApplication1
{
    class Recorder
    {
        int sampleRate = 22000;
        int nBits = 16;
        int channels = 2;
        Boolean isRec = false;

        //private WaveIn waveIn;
        private AsioOut asioOut;
        private WaveFileWriter writer;

        String outputFilename = @"c:\test.wav";

        public Recorder(int sampleRate = 48000, int nBits = 32, int channels = 2)
        {
            this.sampleRate = Properties.Settings.Default.raudSampleRate;
            this.sampleRate = sampleRate;
            this.nBits = nBits;
            this.channels = channels;
            init();
        }

        ~Recorder()
        {
            close();
        }


        private void init()
        {

            asioOut = new AsioOut();//draiveri number

            //asioOut.InputChannelOffset

            asioOut.InitRecordAndPlayback(null, channels, sampleRate);
            asioOut.AudioAvailable += new EventHandler<AsioAudioAvailableEventArgs>(asioOut_AudioAvailable);
            //  asioOut.wa
            asioOut.ShowControlPanel();

        }


        private void close()
        {
            asioOut.Dispose();
        }


        void asioOut_AudioAvailable(object sender, AsioAudioAvailableEventArgs e)
        {
            float[] samples = e.GetAsInterleavedSamples();
            writer.WriteSamples(samples, 0, samples.Length);
        }

        public String stopRec()
        {
            isRec = false;
            asioOut.Pause();
            writer.Flush();
            long lout = writer.Length;
            writer.Close();
            // häkk
            //  writer = null;
            //waveIn.StartRecording();
            //waveIn.StopRecording();
            // /häkk
            return lengthToString(lout);
        }
        public void startRec(String outputFilename)
        {
            this.outputFilename = outputFilename;
            writer = new WaveFileWriter(outputFilename, WaveFormat.CreateIeeeFloatWaveFormat(sampleRate, channels));
            isRec = true;
            asioOut.Play();

        }
        public String lengthToString(long l)
        {
            long bMin = sampleRate * channels * (nBits / 8);
            long secs = l / bMin;
            long ms = l % bMin;
            return secs + ":" + ms;
        }
        public Boolean isRecording()
        {

            return isRec;
        }
    }
}
